declare const LEAF_PREFIX: Buffer;
declare const BRANCH_PREFIX: Buffer;
declare type HashFunction = (buf: Buffer) => Buffer;
declare type MerkleTreeProof = {
    proofs: Buffer[];
    paths: boolean[];
};
declare class MerkleTree {
    leaves: Buffer[];
    layers: Buffer[][];
    nLayers: number;
    hashFn: (buf: Buffer) => Buffer;
    hashSizeBytes: number;
    constructor(items: Buffer[], hashFn: HashFunction);
    root(): Buffer;
    hashLeaf(leaf: Buffer): Buffer;
    hashBranch(left: any, right: Buffer): Buffer;
    findLeafIndex(item: Buffer): number;
    findLeaf(item: Buffer): Buffer;
    generateProof(item: Buffer): MerkleTreeProof;
    verifyProof(proof: MerkleTreeProof, leaf: Buffer): boolean;
    private computeTree;
    private computeLayer;
    toString(): string;
}
declare function hashLeaf(hashFn: HashFunction, leaf: Buffer): Buffer;
declare function hashBranch(hashFn: HashFunction, left: any, right: Buffer): Buffer;
declare function verifyProof(hashFn: HashFunction, proof: MerkleTreeProof, root: Buffer, leaf: Buffer): boolean;
export { MerkleTree, MerkleTreeProof, hashLeaf, hashBranch, verifyProof, LEAF_PREFIX, BRANCH_PREFIX };
//# sourceMappingURL=index.d.ts.map